﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Imaging;
using System.IO;
using System.Threading;

namespace Screenshot
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btnWholeScreen_Click(object sender, EventArgs e)
        {
            CaptureWholeScreen();
        }

        private void btnActiveWindow_Click(object sender, EventArgs e)
        {
            CaptureActiveWindow();
        }

        private void btnCaptureDesktop_Click(object sender, EventArgs e)
        {
            CaptureUsersDesktop();
        }

        public void CaptureUsersDesktop()
        {
            // Rememer to add a reference to Microsoft Shell Controls and Automation
            Shell32.ShellClass shellRef = new Shell32.ShellClass();

            // Show desktop
            ((Shell32.IShellDispatch4)shellRef).ToggleDesktop();

            // Set a delay
            Thread.Sleep(200);

            // Take screenshot
            CaptureWholeScreen();
        }

        public void CaptureActiveWindow()
        {
            // Hide the form so that it does not appear in the screenshot
            this.Hide();

            // Get bound of our screen
            Rectangle bounds = this.Bounds;           

            // Set the bitmap object to the size of the active window
            using (Bitmap bmp = new Bitmap(bounds.Width, bounds.Height))
            {
                // Take screenshow
                using (Graphics gfx = Graphics.FromImage(bmp))
                {
                    gfx.CopyFromScreen(new Point(bounds.Left, bounds.Top), Point.Empty, bounds.Size);
                }

                // Save screenshot to file
                String _path = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.Desktop), "ActiveWindow.jpg");
                bmp.Save(_path);
            }

            // Show the form again
            this.Show();
        }

        public void CaptureWholeScreen()
        {
            // Hide the form so that it does not appear in the screenshot
            this.Hide();

            // Get bound of our screen
            Rectangle bounds = Screen.PrimaryScreen.Bounds;

            // Set the bitmap object to the size of the screen
            using (Bitmap bmp = new Bitmap(bounds.Width, bounds.Height))
            {
                // Take screenshot
                using (Graphics gfx = Graphics.FromImage(bmp))
                {
                    gfx.CopyFromScreen(Point.Empty, Point.Empty, bounds.Size);
                }

                // Save screenshot to file
                String _path = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.Desktop), "WholeScreen.jpg");
                bmp.Save(_path);
            }
                        
            // Show the form again
            this.Show();
        }
    }
}
